<template>
  <div class="promotion-box flex flex-col md:flex-row rounded-xl border-2 border-gray-300 p-3 xl:px-4">
    <div
      :style="{ backgroundImage: `url(${promotion.imageUrl})` }"
      class="bg-cover bg-center mb-4 md:mb-0 md:mr-4 h-44 md:h-auto md:flex-1"
    />
    <div class="md:flex-2">
      <h3 class="font-serif text-lg font-bold mb-4">
        Unsere neueste Premium Aktienanalyse
      </h3>
      <p class="mb-4">
        {{ promotion.text }}
      </p>
      <client-only>
        <a :href="promotion.linkUrl" target="_blank">Jetzt vollständige Analyse lesen</a>
      </client-only>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapState } from 'vuex';

export default Vue.extend({
  data () {
    return {
      promotion: {} as any
    };
  },

  computed: {
    ...mapState({
      promotionFeed: (state: any) => state.feed.alleaktien
    })
  },

  created () {
    if (typeof window !== 'undefined') {
      const parser = new DOMParser();

      try {
        const xmlDoc = parser.parseFromString(this.promotionFeed, 'text/xml');

        const item = xmlDoc.getElementsByTagName('item')[0];
        const text = item.getElementsByTagName('title')[0].textContent;
        const imageUrl = item.getElementsByTagName('content:encoded')[0].textContent || '';

        this.promotion.linkUrl = item.getElementsByTagName('link')[0].textContent;
        this.promotion.text = text;

        let parsedImageUrl = (imageUrl.match(/src="([A-Za-z0-9-_:./]*)"/) || [])[0];

        if (parsedImageUrl) {
          parsedImageUrl = parsedImageUrl.replace('src="', '').replace('"', '');

          this.promotion.imageUrl = parsedImageUrl;
        }
      } catch (ex) {
        console.error('Could not parse RSS feed', ex);
      }
    }
  }
});
</script>

<style lang="scss" scoped>
.promotion-box {
  background-color: #E0FFD1;
}
</style>
